-- --------------------------------------------------------------------
-- @author: lwc@syg.com(必填, 创建模块的人员)
-- @editor: xxx@syg.com(必填, 后续维护以及修改的人员)
-- @description:
--      天赋
-- <br/> 2018年11月20日
-- --------------------------------------------------------------------
HeroTalentSkillLevelUpPanel = HeroTalentSkillLevelUpPanel or BaseClass(BaseView)

local controller = HeroController:getInstance()
local model = controller:getModel()
local string_format = string.format
local table_insert = table.insert
local table_remove = table.remove

function HeroTalentSkillLevelUpPanel:__init()
    self.view_tag = ViewMgrTag.DIALOGUE_TAG
    self.win_type = WinType.Mini   
    self.is_full_screen = false
    self.layout_name = "hero/hero_talent_skill_level_up_panel"

    self.res_list = {
        { path = PathTool.getPlistImgForDownLoad("gw_hero_elfin","gw_hero_elfin"), type = ResourcesType.plist },
        { path = PathTool.getPlistImgForDownLoad("gw_common_01","gw_common_01"), type = ResourcesType.plist },
    }
end

function HeroTalentSkillLevelUpPanel:open_callback()
    self.background = self.root_wnd:getChildByName("background")
    if self.background then
        self.background:setScale(display.getMaxScale())
    end

    self.container = self.root_wnd:getChildByName("container")
    self:playEnterAnimatianByObj(self.container, 2)

    self.title = self.container:getChildByName("title")
    StringUtil.gw_setLabelContent(self.title, UI_TI18N(73023), 370)

    self.close_btn = self.container:getChildByName("close_btn")
    self.close_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            self:onClickBtnClose()
        end
    end)


    self.left_info = self.container:getChildByName("left_info")
    self.left_info_skill_item_node = self.left_info:getChildByName("skill_item_node")
    self.left_info_skill_name = self.left_info:getChildByName("skill_name")
    self.left_info_skill_desc_bg = self.left_info:getChildByName("skill_desc_bg")
    local size = self.left_info_skill_desc_bg:getContentSize()
    self.left_info_skill_desc_scroll = createScrollView(size.width, size.height, 0, 0, self.left_info_skill_desc_bg, ccui.ScrollViewDir.vertical)

    self.right_info = self.container:getChildByName("right_info")
    self.right_info_skill_item_node = self.right_info:getChildByName("skill_item_node")
    self.right_info_skill_name = self.right_info:getChildByName("skill_name")
    self.right_info_skill_desc_bg = self.right_info:getChildByName("skill_desc_bg")
    local size = self.right_info_skill_desc_bg:getContentSize()
    self.right_info_skill_desc_scroll = createScrollView(size.width, size.height, 0, 0, self.right_info_skill_desc_bg, ccui.ScrollViewDir.vertical)

    self.cost_objects = {}
    for i=1,2 do
        local object = {}
        local item = self.container:getChildByName("consume"..i)
        local item_node = item:getChildByName("item_node")
        object.item_node = GW_GoodsItem3.new(false, true, false, 1, nil, true)
        object.item_node:setPosition(cc.p(0, 0))
        object.item_node:gw_showShadow()
        item_node:addChild(object.item_node)
        object.cost_name = item:getChildByName("name")
        object.cost_num = item:getChildByName("num1")
        object.cost_num2 = item:getChildByName("num2")
        object.gw_item = item
        table.insert(self.cost_objects, object)
    end

    self.left_btn = self.container:getChildByName("left_btn")
    self.left_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            self:onClickBtnLeft()
        end
    end)
    self.left_btn_label = self.left_btn:getChildByName("label")
    StringUtil.gw_setLabelContent(self.left_btn_label, UI_TI18N(73024), 220)
    self.left_btn_redpoint = self.left_btn:getChildByName("redpoint")

    self.right_btn = self.container:getChildByName("right_btn")
    self.right_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            self:onClickBtnRight()
        end
    end)
    self.right_btn_label = self.right_btn:getChildByName("label")
    StringUtil.gw_setLabelContent(self.right_btn_label, UI_TI18N(73025), 220)
    self.right_btn_redpoint = self.right_btn:getChildByName("redpoint")


    --self.background = self.root_wnd:getChildByName("background")
    --if self.background ~= nil then
    --    self.background:setScale(display.getMaxScale())
    --end
    --
    --self.main_container = self.root_wnd:getChildByName("main_container")
    --self:playEnterAnimatianByObj(self.main_container , 1)
    --self.title = self.main_container:getChildByName("win_title")
    --self.title:setString(TI18N("技能升级"))
    --
    --
    --self.skill_up_panel = self.main_container:getChildByName("skill_up_panel")
    --local show_item_node = self.skill_up_panel:getChildByName("show_item_node")
    --self.skill_up_info = {}
    --self.skill_up_info.skill_item =  SkillItem.new(true,true,true,nil,nil,false)
    --self.skill_up_info.skill_item:setScale(0.9)
    --show_item_node:addChild(self.skill_up_info.skill_item)
    --self.skill_up_info.skill_name = self.skill_up_panel:getChildByName("skill_name")
    --local dec_node = self.skill_up_panel:getChildByName("dec_node")
    --self.skill_up_info.skill_desc = createRichLabel(22, cc.c4b(0x64,0x32,0x23,0xff), cc.p(0, 1), cc.p(0,0),nil,nil,440)
    --dec_node:addChild(self.skill_up_info.skill_desc)
    --
    --
    --self.skill_down_panel = self.main_container:getChildByName("skill_down_panel")
    --local show_item_node = self.skill_down_panel:getChildByName("show_item_node")
    --self.skill_down_info = {}
    --self.skill_down_info.skill_item =  SkillItem.new(true,true,true,nil,nil,false)
    --self.skill_down_info.skill_item:setScale(0.9)
    --show_item_node:addChild(self.skill_down_info.skill_item)
    --self.skill_down_info.skill_name = self.skill_down_panel:getChildByName("skill_name")
    --local dec_node = self.skill_down_panel:getChildByName("dec_node")
    --self.skill_down_info.skill_desc = createRichLabel(22, cc.c4b(0x64,0x32,0x23,0xff), cc.p(0, 1), cc.p(0,0),nil,nil,440)
    --dec_node:addChild(self.skill_down_info.skill_desc)
    --
    --
    --self.box_90025_2 = self.main_container:getChildByName("box_90025_2")
    --self.page_name_1 = self.main_container:getChildByName("page_name_1")
    --self.page_name_1:setString(TI18N("技能升级"))
    --self.page_name_2 = self.main_container:getChildByName("page_name_2")
    --self.page_name_2:setString(TI18N("升级消耗"))
    --self.cost_node = self.main_container:getChildByName("cost_node")
    --
    --self.left_btn = self.main_container:getChildByName("left_btn")
    --self.left_btn:getChildByName("label"):setString(TI18N("遗忘技能"))
    --self.right_btn = self.main_container:getChildByName("right_btn")
    --self.right_btn:getChildByName("label"):setString(TI18N("升 级"))
    --
    --self.arrow = self.main_container:getChildByName("Sprite_1")
    --self.skill_max_label = self.main_container:getChildByName("skill_max_label")
    --self.skill_max_label:setString("")
    ---- self.close_btn = self.main_container:getChildByName("close_btn")
end

function HeroTalentSkillLevelUpPanel:register_event()
    --registerButtonEventListener(self.background, handler(self, self.onClickBtnClose) ,false, 1)
    ---- registerButtonEventListener(self.close_btn, handler(self, self.onClickBtnClose) ,false,2)
    --registerButtonEventListener(self.left_btn, handler(self, self.onClickBtnLeft) ,true, 2)
    --registerButtonEventListener(self.right_btn, handler(self, self.onClickBtnRight) ,true, 2)

    self:addGlobalEvent(HeroEvent.Hero_Level_Up_Talent_Event, function(data)
        if not data then return end
        if not self.hero_vo then return end
        if data.partner_id == self.hero_vo.partner_id then
            local skill_id = self.hero_vo.talent_skill_list[self.pos]
            self:initSkillInfo(skill_id)
        end
    end)
end

--关闭
function HeroTalentSkillLevelUpPanel:onClickBtnClose()
    controller:openHeroTalentSkillLevelUpPanel(false)
end

--遗忘
function HeroTalentSkillLevelUpPanel:onClickBtnLeft()
    if not self.skill_id then return end
    if not self.hero_vo then return end
    if not self.pos then return end
    local cost_config = Config.PartnerSkillData.data_partner_skill_back_fun(self.skill_id)
    if cost_config then
        if #cost_config.expend == 0 then
            controller:sender11098(self.hero_vo.partner_id, self.pos)
            self:onClickBtnClose()
            return
        end
        --local str = TI18N("遗忘该技能需消耗 ")
        local cost_str = ""
        local get_str = ""
        for i,v in ipairs(cost_config.expend) do
            local item_config = Config.ItemData.data_get_data(v[1])
            if item_config then
                if i ~= 1 then
                    cost_str = cost_str..","
                end
                local str1 = StringFormat(UI_TI18N(73026),PathTool.getItemRes(item_config.icon), v[2])
                cost_str = cost_str..str1
                --if i ~= 1 then
                --    str = str..", "
                --end
                --local str1 = string_format(TI18N("<img src=%s visible=true scale=0.32 /><div fontColor=#289b14 fontsize= 24>%s</div>"),PathTool.getItemRes(item_config.icon), v[2])
                --str = str..str1
            end
        end
        if #cost_config.award1 > 0 then
            --str = str.."\n(同时返还 "
            for i,v in ipairs(cost_config.award1) do
                local item_config = Config.ItemData.data_get_data(v[1])
                if item_config then
                    if i ~= 1 then
                        get_str = get_str..","
                    end
                    local str1 = StringFormat(UI_TI18N(73027),PathTool.getItemRes(item_config.icon), v[2])
                    get_str = get_str..str1
                    --if i ~= 1 then
                    --    str = str..", "
                    --end
                    --local str1 = string_format(TI18N("<img src=%s visible=true scale=0.32 /><div fontColor=#289b14 fontsize= 24>%s</div>"),PathTool.getItemRes(item_config.icon), v[2])
                    --str = str..str1
                end
            end
            --str = str..")"
        end

        local str = ""
        if get_str ~= "" then
            str = StringFormat(UI_TI18N(73028), cost_str, get_str)
        else
            str = StringFormat(UI_TI18N(73029), cost_str)
        end

        local function fun()
            controller:sender11098(self.hero_vo.partner_id, self.pos)
            self:onClickBtnClose()
        end
        CommonAlert.show(str, UI_TI18N(41183), fun, UI_TI18N(41180), nil, CommonAlert.type.rich, nil, nil, nil, true)
    else
        controller:sender11098(self.hero_vo.partner_id, self.pos)
        self:onClickBtnClose()
    end
end
--升级
function HeroTalentSkillLevelUpPanel:onClickBtnRight()
    if not self.hero_vo then return end
    if not self.pos then return end
    controller:sender11097(self.hero_vo.partner_id, self.pos)
end

function HeroTalentSkillLevelUpPanel:openRootWnd(hero_vo, skill_id, pos)
    if not hero_vo then return end
    if not pos then return end
    if not skill_id then return end
    self.pos = pos
    self.hero_vo = hero_vo
    self:initSkillInfo(skill_id)
end

function HeroTalentSkillLevelUpPanel:initSkillInfo(skill_id)
    if not skill_id then return end
    local config = Config.PartnerSkillData.data_partner_skill_level_fun(skill_id)
    self.skill_id = skill_id
    if config then
        self:gw_showCurSkillInfo(config.id)
        self:gw_showNextSkillInfo(config.next_id)
        self:showCostInfo(config)

        self.right_btn:setTouchEnabled(true)
        setChildUnEnabled(false, self.right_btn)
        StringUtil.gw_setLabelContent(self.right_btn_label, UI_TI18N(73025), 220)
        self.right_btn_label:enableOutline(cc.c4b(0x0b,0x7e,0xb3,0xff),2)
    else
        self:gw_showCurSkillInfo(skill_id)
        self:gw_showNextSkillInfo(skill_id)

        for i,v in pairs(self.cost_objects) do
            v.gw_item:setVisible(false)
        end

        self.right_btn:setTouchEnabled(false)
        setChildUnEnabled(true, self.right_btn)
        StringUtil.gw_setLabelContent(self.right_btn_label, UI_TI18N(73030), 220)
        self.right_btn_label:disableEffect(cc.LabelEffect.OUTLINE)
    end
    --if config then
    --    self:showSkillInfo(config.id, self.skill_up_info)
    --    self:showSkillInfo(config.next_id, self.skill_down_info)
    --    self:showCostInfo(config)
    --else
    --    self:showSkillInfo(skill_id, self.skill_up_info)
    --    self.box_90025_2:setVisible(false)
    --    self.page_name_2:setVisible(false)
    --    self.arrow:setVisible(false)
    --    self.right_btn:setVisible(false)
    --    self.skill_max_label:setString(TI18N("该技能已满级"))
    --    self.skill_down_panel:setVisible(false)
    --    for i,item in ipairs(self.item_list) do
    --        item:setVisible(false) --相当于隐藏
    --    end
    --
    --    self.skill_bg = createSprite(nil,337,298,self.main_container,cc.p(0.5,0.5), LOADTEXT_TYPE)
    --    self.skill_bg:setZOrder(1)
    --    local bg_res = PathTool.getPlistImgForDownLoad("bigbg/hero","hero_talent_skill_max", false)
    --    self.item_load = loadSpriteTextureFromCDN(self.skill_bg, bg_res, ResourcesType.single, self.item_load)
    --    self.skill_max_label:setZOrder(2)
    --    self.skill_max_label:setPositionY(307)
    --    self.left_btn:setZOrder(2)
    --    self.left_btn:setPosition(self.main_container:getContentSize().width * 0.5 , 61)
    --end
end

--function HeroTalentSkillLevelUpPanel:showSkillInfo(skill_id, skill_info)
--    local config = Config.SkillData.data_get_skill(skill_id)
--    if not config then return end
--    if skill_info.skill_item then
--        skill_info.skill_item:setData(config)
--    end
--    skill_info.skill_name:setString(config.name)
--    skill_info.skill_desc:setString(config.des)
--end

function HeroTalentSkillLevelUpPanel:gw_showCurSkillInfo(skill_id)
    local config = Config.SkillData.data_get_skill(skill_id)
    if config then
        self.left_info_skill_name:setString(config.name)
        if self.left_info_skill_item == nil then
            self.left_info_skill_item = SkillItem.new()
            self.left_info_skill_item = SkillItem.new(false,false,false,1,false,false)
            self.left_info_skill_item:setPosition(0, 0)
            self.left_info_skill_item_node:addChild(self.left_info_skill_item)
        end
        self.left_info_skill_item:setData(config)

        -- 描述
        if not self.left_info_skill_desc then
            self.left_info_skill_desc = createRichLabel(20, cc.c4b(0x69,0x69,0x69,0xff), cc.p(0, 1), cc.p(17, 0), nil, nil, 378)
            self.left_info_skill_desc_scroll:addChild(self.left_info_skill_desc)
        end
        self.left_info_skill_desc:setString(config.des)
        local skill_des_height = self.left_info_skill_desc:getContentSize().height
        local max_height = math.max(skill_des_height + 32, 167)
        self.left_info_skill_desc:setPositionY(max_height - 16)
        self.left_info_skill_desc_scroll:setInnerContainerSize(cc.size(self.left_info_skill_desc_scroll:getContentSize().width, max_height))
        self.left_info_skill_desc_scroll:setTouchEnabled(max_height > 167)
    else
        self.left_info_skill_name:setString("")
        if self.left_info_skill_item then
            self.left_info_skill_item:setVisible(false)
        end
        self.left_info_skill_desc_scroll:setVisible(false)
        Debug.error("找不到技能配置！！ID:"..skill_id)
    end
end
function HeroTalentSkillLevelUpPanel:gw_showNextSkillInfo(skill_id)
    local config = Config.SkillData.data_get_skill(skill_id)
    if config then
        self.right_info_skill_name:setString(config.name)
        if self.right_info_skill_item == nil then
            self.right_info_skill_item = SkillItem.new()
            self.right_info_skill_item = SkillItem.new(false,false,false,1,false,false)
            self.right_info_skill_item:setPosition(0, 0)
            self.right_info_skill_item_node:addChild(self.right_info_skill_item)
        end
        self.right_info_skill_item:setData(config)
        self.right_info_skill_item:setVisible(true)

        -- 描述
        if not self.right_info_skill_desc then
            self.right_info_skill_desc = createRichLabel(20, cc.c4b(0x69,0x69,0x69,0xff), cc.p(0, 1), cc.p(17, 0), nil, nil, 378)
            self.right_info_skill_desc_scroll:addChild(self.right_info_skill_desc)
        end
        self.right_info_skill_desc:setString(config.des)
        local skill_des_height = self.right_info_skill_desc:getContentSize().height
        local max_height = math.max(skill_des_height + 32, 167)
        self.right_info_skill_desc:setPositionY(max_height - 16)
        self.right_info_skill_desc_scroll:setInnerContainerSize(cc.size(self.right_info_skill_desc_scroll:getContentSize().width, max_height))
        self.right_info_skill_desc_scroll:setTouchEnabled(max_height > 167)
        self.right_info_skill_desc_scroll:setVisible(true)
    else
        self.right_info_skill_name:setString("")
        if self.right_info_skill_item then
            self.right_info_skill_item:setVisible(false)
        end
        self.right_info_skill_desc_scroll:setVisible(false)
        Debug.error("找不到技能配置！！ID:"..skill_id)
    end
end

function HeroTalentSkillLevelUpPanel:showCostInfo(config)
    if not config then return end

    for i,v in pairs(self.cost_objects) do
        v.gw_item:setVisible(false)
    end
    for i,v in ipairs(config.expend) do
        local item_bid = v[1]
        local item_num = v[2]
        local item_cfg = Config.ItemData.data_get_data(item_bid)
        local object = self.cost_objects[i]
        if item_cfg and object then
            object.item_node:setData(item_cfg)
            object.item_node:showNumLabel(false)
            if i==1 then
                StringUtil.gw_setLabelContent(object.cost_name, item_cfg.name, 130)
            elseif i==2 then
                StringUtil.gw_setLabelContent(object.cost_name, item_cfg.name, 230)
            end
            local have_num = BackpackController:getInstance():getModel():getItemNumByBid(item_bid)
            object.cost_num:setString(StringFormat("/{0}", MoneyTool.GetMoneyString(item_num, false)))
            object.cost_num2:setString(StringFormat("{0}", MoneyTool.GetMoneyString(have_num, false)))
            local scale = 1
            if i==1 then
                if object.cost_num:getContentSize().width + object.cost_num2:getContentSize().width > 90 then
                    scale = (object.cost_num:getContentSize().width + object.cost_num2:getContentSize().width)/90
                end
            elseif i==2 then
                if object.cost_num:getContentSize().width + object.cost_num2:getContentSize().width > 210 then
                    scale = (object.cost_num:getContentSize().width + object.cost_num2:getContentSize().width)/210
                end
            end
            object.cost_num:setScale(scale)
            object.cost_num2:setScale(scale)
            object.cost_num2:setPositionX(object.cost_num:getPositionX() - object.cost_num:getContentSize().width * scale)
            if have_num < item_num then
                object.cost_num2:setTextColor(cc.c3b(0xff,0x23,0x1e))
            else
                object.cost_num2:setTextColor(cc.c3b(0x55,0xed,0x40))
            end

            object.gw_item:setVisible(true)
        end
    end


    --for i,item in ipairs(self.item_list) do
    --    item:setPositionX(10000) --相当于隐藏
    --end
    --
    --local item_width = BackPackItem.Width + 160
    --local start_x = - item_width * #config.expend/2 + 80
    --for i,cost in ipairs(config.expend) do
    --    if self.item_list[i] == nil then
    --        self.item_list[i] = BackPackItem.new(true, true)
    --        self.item_list[i]:setAnchorPoint(0.5, 0.5)
    --        self.item_list[i]:setScale(0.8)
    --
    --        self.cost_node:addChild(self.item_list[i])
    --    end
    --    local _x = start_x + (i - 1) * item_width
    --    self.item_list[i]:setPosition(_x, 0)
    --    local item_config = Config.ItemData.data_get_data(cost[1])
    --    if item_config then
    --        -- self.item_list[i]:setBaseData(cost[1], cost[2], true)
    --        self.item_list[i]:setData(item_config)
    --        local have_num = BackpackController:getInstance():getModel():getItemNumByBid(item_config.id)
    --        self.item_list[i]:setNeedNum2(cost[2], have_num)
    --        self.item_list[i]:setDefaultTip(true, nil, nil , 1)
    --        -- local name = string_format("%sx%s", item_config.name, cost[2])
    --        self.item_list[i]:setGoodsName(item_config.name,cc.p(174,61),24,cc.c4b(0x64,0x32,0x23,0xff))
    --    end
    --end
end

function HeroTalentSkillLevelUpPanel:close_callback()
    --if self.list_view then
    --    self.list_view:DeleteMe()
    --    self.list_view = nil
    --end
    --
    --if self.skill_up_info and self.skill_up_info.skill_item then
    --    self.skill_up_info.skill_item:DeleteMe()
    --    self.skill_up_info = nil
    --end
    --if self.skill_down_info and self.skill_down_info.skill_item then
    --    self.skill_down_info.skill_item:DeleteMe()
    --    self.skill_down_info = nil
    --end
    --
    --if self.item_load then
    --    self.item_load:DeleteMe()
    --end
    --self.item_load = nil

    for k,object in pairs(self.cost_objects) do
        if object.item_node then
            object.item_node:DeleteMe()
            object.item_node = nil
        end
    end

    if self.left_info_skill_item then
        self.left_info_skill_item:DeleteMe()
        self.left_info_skill_item = nil
    end
    if self.right_info_skill_item then
        self.right_info_skill_item:DeleteMe()
        self.right_info_skill_item = nil
    end

    controller:openHeroTalentSkillLevelUpPanel(false)
end